import { Store } from 'redux';
declare type GetFirstArgFn<F> = F extends (a: infer A1, ...args: infer _U) => void ? (a: A1) => void : unknown;
declare type GetFirstArgOfObj<T> = {
    readonly [P in keyof T]: GetFirstArgFn<T[P]>;
};
export declare type HandleReducerMap<T> = {
    readonly [P in keyof T]: GetFirstArgOfObj<T[P]>;
};
export declare type HandleActionMap<T> = {
    readonly [P in keyof T]: {
        readonly [P2 in keyof T[P]]: string;
    };
};
export declare type RunParams<ReducerModules> = {
    readonly modules: any;
    readonly middlewares?: readonly any[];
};
export declare type RunResult<ReducerModules> = {
    readonly store: Store;
    readonly actions: HandleActionMap<ReducerModules>;
    readonly reducers: HandleReducerMap<ReducerModules>;
    readonly selectors: Record<string, unknown>;
    readonly effects: Record<string, unknown>;
};
export declare type RunFunc<T> = {
    (options: RunParams<T>): RunResult<T>;
};
export declare type MutableObject = Record<string, unknown>;
export declare type ReducerModuleConfig = {
    namespace: string;
    state: unknown;
    reducer: Record<string, unknown>;
};
export declare type Options<Namespace, State, Reducer, Selector> = {
    readonly namespace: Namespace;
    readonly state: State;
    readonly reducer: Reducer;
    readonly selector?: Selector;
};
export {};
